//Datei: DS1821IO.C
// Hauptprogramm
// Temperatur messen mit PIC16F84
// und DS1821
//
// Holger Klabunde
// Copyright 2000
// 22.04.2001
// Compiler PICCLite

#include "prozess.h"      /* Der verwendete Prozessor */
#include "ds1821.h"
#include "protos.h"

//Sendet die Master Reset Sequenz
//Und fragt Presence ab
unsigned char MasterReset()
{
 unsigned char timeout;
 
 timeout=0;
 if(DQ==0) return 1; //DS arbeitet evtl. als Thermostat !
 
 DQ=0; //Fr Master Reset DQ=0;
 Delay100us(6); //Fr min. 480us     
 DQ=1; //Leitung freigeben
 Delay10us();
 while(DQ==1) //Warten bis DS sich meldet
  {
   timeout++;
   if(timeout>20) return 1; //Nach max. 60us sollte DS sich melden
   Delay10us();
  }
  
 while(DQ==0); //Presence Pulse abwarten
 Delay100us(6); //Fr min. 480us     

 return 0; //DS hat geantwortet
}

void SendByte(unsigned char by)
{
 unsigned char mask,i;
 mask=0x01;

 for(i=0; i<8; i++) //8Bits senden
  {
   if((mask&by)==0) //Ein 0-Bit
    {
     DQ=0; //Jetzt min 60us warten
     Delay10us(); Delay10us(); 
     Delay10us(); Delay10us(); 
     Delay10us(); Delay10us(); 
     Delay10us(); Delay10us(); 
    }
   else             //Ein 1-Bit
    {
     DQ=0;
     NOP(); NOP(); 
    } 

   DQ=1; Delay100us(1);
   mask<<=1; //Nchstes Bit
  }
}

int ReadByte()
{
 int by;
 unsigned char mask,i;

 mask=0x01;
 by=0;
 
 for(i=0; i<8; i++) //8Bits empfangen
  {
   DQ=0; //Flanke fr DS
   NOP(); NOP(); //Kurz warten
   DQ=1; //Leitung freigeben

   NOP(); NOP(); NOP(); NOP(); //Kurz warten
   NOP(); NOP(); NOP(); NOP(); //Kurz warten

   if(DQ==1) by|=mask;
   else while(DQ==0);  //Lange 0-Phase vom DS abwarten
   Delay10us();
   
   mask<<=1; //Nchstes Bit
  }

 return by;
}
